module Spwd 
 (  
    -- API
      getSpwdName
    , putSpwd
 )
where

import SecLibTypes
import SecLib
import Files

import SpwdData

path_Shadow :: File H
path_Shadow = highF

path_Passwd :: FilePath
path_Passwd = "./passwd"



getSpwdName :: Name -> IO (Maybe (Sec H Spwd))
getSpwdName nam = do  se  <- parseSpwd
                      pw <- parsePwd
                      case lookup nam pw of
                            Nothing  -> return Nothing
                            Just n   -> return $ Just ((\e -> case lookup n e of
                                                   Nothing -> error "impossible"
                                                   Just c  -> Spwd { uid = n , cypher = c}) `fmap` se)
putSpwd :: Spwd -> IO (Sec H ())
putSpwd spwd = do se  <- parseSpwd
                  let secio = do e <- value se 
                                 let (id, c) = (uid spwd, cypher spwd)
                                     (ts,ds) = span (\(u,_) -> u /= id ) e 
                                     updated = if null ds 
                                                  then ts++[(id,c)]            -- new record
                                                  else ts++[(id,c)]++(tail ds) -- update
	                         s_write path_Shadow (show updated) 
                  run secio


parseSpwd :: IO (Sec H [(UID, Cypher)])
parseSpwd = run ( do s <- s_read path_Shadow
                     (s == s) `seq` return (read s :: [(UID, Cypher)]))

parsePwd :: IO ([(Name, UID)])
parsePwd = do s <- readFile path_Passwd
              (s == s) `seq` return (read s :: [(Name, UID)])
