module Sec where

import Lattice

-- Sec
newtype Sec s a = MkSec a


instance Functor (Sec s) where
  h `fmap` (MkSec x) = MkSec (h x)


instance Monad (Sec s) where
  return x = sec x

  MkSec a >>= k =
    MkSec (let MkSec b = k a in b)

sec :: a -> Sec s a
sec x = MkSec x

open :: Sec s a -> s -> a
open (MkSec a) s = s `seq` a

up :: Less s s' => Sec s a -> Sec s' a
up sec_s@(MkSec a) = less s s' `seq` sec_s' 
                     where (sec_s') = MkSec a 
                           s      = unSecType sec_s 
                           s'     = unSecType sec_s'

-- only for trusted code!
reveal :: Sec s a -> a
reveal (MkSec a) = a

-- Internal function, not exported. For type-checking purposes.
unSecType :: Sec s a -> s 
unSecType _ = undefined


-- for untrusted code!
public :: Sec L a -> a 
public (MkSec a) = a
