module DeclCombinators
( 
    hatch
  , ntimes
  , when 
  , who
  , certify 
)

where

import Sec ( open, reveal )
import Data.IORef
import DeclCombinatorsTypes
import Lattice ( Less )

hatch :: Less s' s => (a -> b) -> Hatch s s' a b  
hatch f = \sa -> return ( Just ( return ( f (reveal sa) ) ) )


ntimes :: Int -> Hatch s s' a b -> IO (Hatch s s' a b)  
ntimes n f = do ref <- newIORef n
                return $ \sa ->
                              do k <- readIORef ref
                                 if k <= 0
                                    then do return Nothing
                                    else do writeIORef ref (k-1)
                                            f sa 



when :: Hatch s s' a b -> IO (Hatch s s' a b, Open, Close)  
when f = do ref <- newIORef False 
            return (\sa -> do b <- readIORef ref
                              if b then f sa 
                                   else return Nothing 
                    , writeIORef ref True 
                    , writeIORef ref False
                   )
 


who :: Hatch s s' a b -> IO (Hatch s s' a b, Authority s )  
who f = do (whof, open, close) <- when f
           return (whof, Authority open close) 

certify :: s -> Authority s -> IO a -> IO a 
certify s (Authority open close) io = 
  s `seq` ( do open ; a <- io ; close ; return a )
